#include <syslog.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/socket.h>
#include <malloc.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <netinet/in.h>

extern	char	*getentry ();

/* Unimplimented 
utmp_W(msgg)
	char	*msgg;
{
	FILE	*utmp_file;

	if((utmp_file=fopen(getentry("UtmpLog"), "a"))) {
		fputs(msgg, utmp_file);
		fflush(utmp_file);
	}

	fclose(utmp_file);
}
*/

error_W(msg)
	char	*msg;
{
	FILE	*err_file;

	if(msg[0] == '\0' || msg[0] == '\n' || msg[0] == '\r')
			return;

	if(msg[strlen(msg) - 1] != '\n' || msg[strlen(msg) - 1] != '\r')
			strcat(msg, "\n"); /* Tag return before write */

	if((err_file = fopen(getentry("ErrorLog"), "a"))) {
		fputs(msg, err_file);
		fflush(err_file);
	}

	fclose(err_file);
}

error_()
{
	char	inpu[BUFSIZ];
	int	t=0, _ch=0;

	syslog(LOG_NOTICE, "Getting error input...\n");
	for(;;) {
		memset(inpu, 0, sizeof(inpu));
		
		for(t=0;(_ch = getchar()) != '\n';t++) {
			if(_ch == EOF || _ch == '\n' || _ch == '\r')
				break;

			inpu[t] = _ch;
		}

		if(!strncmp(inpu, "&error", 6))
			break;

		error_W(inpu);
	}
}
/* Unimplimented
utmp_() {
	char it[BUFSIZ];
	int j=0, chrs=0;

	for(;;) {
		memset(it, 0, sizeof(it));
		syslog(LOG_NOTICE, "Getting utmp...\n");

		for(j=0;;j++) {
			chrs = getchar();

			if(chrs == '\n') {
				if(!strncmp(it, "&utmp", 5))
					break;
			}

			if((chrs == '$') && (it[j - 1] == '\n'))
					break;

			it[j] = chrs;
		}

		if(!strncmp(it, "&utmp", 5))
			break;

		utmp_W(it);
	}
}
*/

main() {
	struct	hostent *h;
	struct	sockaddr_in from;
	char	host[BUFSIZ], temp[BUFSIZ], domain[BUFSIZ];
	char	_time[BUFSIZ], *hostlist, input[BUFSIZ];
	char	*pnt, pass[BUFSIZ];
	time_t	tt=time(NULL);
	register	char	*p;
	int	v=0, i=0, chr=0, ch=0;
	size_t	fromlen;

	fromlen = sizeof(from);
	if(getpeername(0, (struct sockaddr *)&from, &fromlen) < 0) {
		fprintf(stdout, "ERROR\n");
		fflush(stdout);
		exit(1);
	}

	h=gethostbyaddr((char *)&from.sin_addr, sizeof(struct in_addr),
		from.sin_family);

	if(h)
		strcpy(host, h->h_name);
	else
		strcpy(host, inet_ntoa(from.sin_addr));

	/* Check host. */
	hostlist=getentry("HostsAllow");
	pnt=strtok(hostlist, ":");

	if(!strcmp(host, pnt)) {
		fprintf(stdout, "OK\n\r");
		fflush(stdout);
		goto begin;
	}

	while((pnt=strtok(NULL,":"))) {
		if(!strcmp(host, pnt)) {
			fprintf(stdout, "OK\n\r");
			fflush(stdout);
			goto begin;
		}
	}

	gethostname(domain, BUFSIZ);
	strcpy(_time, ctime(&tt));
	_time[strlen(_time) - 1] = 0;

	sprintf(temp, "%s %s in.lbd[%d]: '%s' failed host authentication.\n", _time, domain, getpid(), host);
	error_W(temp);

begin:
	for(v=0;(ch = getchar()) != '\n'; v++) {
		if(ch == EOF || ch == '\n' || ch == '\r')
			break;

		pass[v] = ch;
	}

	p = crypt(pass, getentry("Password"));

	if(!strcmp(p, getentry("Password"))) {
		fprintf(stdout, "OK\n\r");
		fflush(stdout);
	} else {
		fprintf(stdout, "ERROR\n\r");
		fflush(stdout);
		exit(1);	
	}

	memset(input, 0, sizeof(input));
	for(;;) { /* Everything passed. lets go */
		memset(input, 0, sizeof(input));
		for(i=0;(chr = getchar()) != '\n';i++) {
			if(chr == EOF || chr == '\n' || chr == '\r')
				break;

			input[i] = chr;
		}

		if(!strncmp(input, "bye", 3))
			exit(0);

		if(!strncmp(input, "&error", 6))
			error_();

//		if(!strncmp(input, "&utmp", 5))
//			utmp_();

	}

}
